extends Node


func co1() -> Foo:
	await get_tree().process_frame
	return Foo.new("bar")


func co2() -> TestClass.FooSub:
	await get_tree().process_frame
	return TestClass.FooSub.new("bar")


func _ready() -> void:
	var foo1 = await co1()
	assert(foo1 != null and foo1.bar == "bar") # Passes
	
	var foo2 = await co2()
	assert(foo2 != null and foo2.bar == "bar") # Passes
	
	var foo3 := await co1() as Foo
	assert(foo3 != null and foo3.bar == "bar") # Passes
	
	var foo4 := await co2() as TestClass.FooSub
	assert(foo4 != null and foo4.bar == "bar") # Fails
